"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RegexCheck = exports.CombinedRegex = exports.OtherDomainsRegex = exports.OtherDiscordDomainsRegex = exports.DefaultDiscordDomainsRegex = void 0;
const defaultOptions = {
    checkDefaultDiscordDomains: true,
    checkOtherDiscordDomains: true,
    checkOtherDomains: false
};
exports.DefaultDiscordDomainsRegex = /discord(?:app\.com\/invite|\.(?:(?:com|co)\/invite|gg))\/[a-zA-Z0-9]{2,100}/gi;
exports.OtherDiscordDomainsRegex = /(?:watchanimeattheoffice|discordsays)\.com\/invite\/[a-zA-Z0-9]{2,100}/gi;
exports.OtherDomainsRegex = /(?:disboard\.org\/(?:(?:en\/)?|pl\/)server\/join|discordhome\.com\/join\/|discord\.me\/server\/join\/)\/[a-zA-Z0-9]{2,100}/gi;
exports.CombinedRegex = new RegExp(`(${exports.DefaultDiscordDomainsRegex.source})|(${exports.OtherDiscordDomainsRegex.source})|(${exports.OtherDomainsRegex.source})`, "gi");
// Check if a string contains a Discord invite link
const RegexCheck = (value, options = defaultOptions) => {
    var _a;
    const formattedOptions = Object.assign(Object.assign({}, defaultOptions), options);
    const urls = value.match(exports.CombinedRegex);
    let parsedURLs = [];
    if (urls) {
        for (const url of urls) {
            const code = url.split("/").pop();
            if (code) {
                if (!((_a = formattedOptions.ignoreCodes) === null || _a === void 0 ? void 0 : _a.includes(code))) {
                    if (formattedOptions.checkDefaultDiscordDomains) {
                        if (url.match(exports.DefaultDiscordDomainsRegex)) {
                            parsedURLs.push(url);
                        }
                    }
                    if (formattedOptions.checkOtherDiscordDomains) {
                        if (url.match(exports.OtherDiscordDomainsRegex)) {
                            parsedURLs.push(url);
                        }
                    }
                    if (formattedOptions.checkOtherDomains) {
                        if (url.match(exports.OtherDomainsRegex)) {
                            parsedURLs.push(url);
                        }
                    }
                }
            }
        }
    }
    return parsedURLs.length > 0 ? true : false;
};
exports.RegexCheck = RegexCheck;
